#include <stdio.h>
#include "ap.h"

struct {
    unsigned print_help;
    long count;
    unsigned verbosity;
    long archive_version;
    const char *archive;
    const char *files[10];
} args;
static struct ap_opt opts[] = {
    { 'h', "help",      AP_NOARG | AP_BOOL,                   &args.print_help,      "print this help" },
    { 'c', "count",     AP_ARG | AP_INT,                      &args.count,           "the number of lines to count" },
    { 'v', "verbose",   AP_NOARG | AP_INT,                    &args.verbosity,       "verbosity level" },
    { 'V', "version=N", AP_ARG | AP_INT,                      &args.archive_version, "archive version" },
    { 0,   "=ARCHIVE",  AP_ARG | AP_STR,                      &args.archive,         "the archive to operate on" },
    { 0,   "=FILE",     AP_MULTIARG | AP_ATLEASTONE | AP_STR, args.files,            "the files to operate on", 10 },
    { 0 }
};

int main(int argc, char *argv[])
{
    struct ap_res res;
    int ret = ap_parse(opts, &res, argv + 1, argc - 1);

    if (args.print_help) {
        ap_help(opts, argv[0], "Count something in archive files.\n", "This program is released without any warranty.\n");
        return 0;
    }
    if (ret < 0) {
        fprintf(stderr, "%s: %s\n", res.errdef, res.errmsg);
        ap_usage(opts, argv[0]);
        return 1;
    }
    return 0;
}

